#ifndef ___MAIN_H___
#define ___MAIN_H___

#define JAL_OPCODE	0x0C000000
#define J_OPCODE	0x08000000
#define SC_OPCODE	0x0000000C
#define JR_RA		0x03e00008

#define NOP	0x00000000

#define MAKE_JUMP(a, f) _sw(J_OPCODE | (((u32)(f) & 0x0ffffffc) >> 2), a); 
#define MAKE_CALL(a, f) _sw(JAL_OPCODE | (((u32)(f) >> 2)  & 0x03ffffff), a); 
#define MAKE_SYSCALL(a, n) _sw(SC_OPCODE | (n << 6), a);
#define JUMP_TARGET(x) (0x80000000 | ((x & 0x03FFFFFF) << 2))

#define REDIRECT_FUNCTION(a, f) _sw(J_OPCODE | (((u32)(f) >> 2)  & 0x03ffffff), a);  _sw(NOP, a+4);
#define MAKE_DUMMY_FUNCTION0(a) _sw(0x03e00008, a); _sw(0x00001021, a+4);
#define MAKE_DUMMY_FUNCTION1(a) _sw(0x03e00008, a); _sw(0x24020001, a+4);

extern SEConfig config;
extern u8 videoiso_mounted;

void ClearCaches();
u32  sctrlHENFindFunction(const char* szMod, const char* szLib, u32 nid);
void PatchSyscall(u32 funcaddr, void *newfunc);
void UndoSuperNoPlainModuleCheckPatch();
int SetBootFile(int n);

void ReturnToDisc();
void Fix150Path(const char *file);
void Fix5XXPath(const char *file);

#define FindProc sctrlHENFindFunction


#endif

